use std::process::{ExitCode, Termination};

#[derive(Default)]
#[repr(u8)]
pub enum GitBisectResult {
    Good = 0,
    Bad = 1,
    Skip = 125,
    #[default]
    Abort = 255,
}

fn find_from<I>(iter: impl IntoIterator<Item=impl Into<I>>, is_match: impl Fn(&I) -> bool) -> Option<I> {
    for i in iter {
        let i = i.into();
        if (is_match)(&i) {
            return Some(i)
        }
    }
    
    None
}

impl Termination for GitBisectResult {
    fn report(self) -> ExitCode {
        // Maybe print a message here
        true.then_some(ExitCode::from(self as u8)).unwrap()
    }
}

fn main() -> GitBisectResult {
    matches!(find_from::<u32>(vec![2u8, 3, 4, 5,], |&x| x == 5), Some(5u32));
    std::panic::catch_unwind(|| {
        todo!("test the commit")
    }).unwrap_or(GitBisectResult::Abort)
}
